///////////////////////////////////////////////////////////
//  ConnectionInformation.cs
//  Implementation of the Class ConnectionInformation
//  Generated by Enterprise Architect
//  Created on:      18-nov-2016 13:07:44
//  Original author: M02AMIOL
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.ComponentModel.DataAnnotations;

namespace STM.Common.DataAccess.Entities
{
    	/// <summary>
	/// Contains timestamp for last known contact with specified component (such as STM
	/// Module)
	/// </summary>
    public class ConnectionInformation
    {

        /// <summary>
        /// Name on component (e.g. STM Module)
        /// </summary>
        public string Component { get; set; }

        public long ID { get; set; }

        /// <summary>
        /// Date and time for last interaction with STM Module.
        /// </summary>
        public DateTime LastInteraction { get; set; }

        /// <summary>
        /// Known status on connection to STM Module (ship or ship representative)
        /// -1=Unknown
        /// 0=Not connected
        /// 1=Connected
        /// </summary>
        [Required]
        public ConnectionStatus Status { get; set; }

        public DateTime StatusSavedAt { get; set; }

    }//end ConnectionInformation
}
