///////////////////////////////////////////////////////////
//  LogEvent.cs
//  Implementation of the Class LogEvent
//  Generated by Enterprise Architect
//  Created on:      18-nov-2016 13:06:54
//  Original author: M02AMIOL
///////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace STM.Common.DataAccess.Entities
{

    /// <summary>
    /// Contains event log for evaluation of STM
    /// </summary>
    public class LogEvent
    {

        /// <summary>
        /// Unique internal id
        /// </summary>
        public long ID { get; set; }

        /// <summary>
        /// Timestamp of log, DateTime in UTC
        /// </summary>
        public DateTime EventTime { get; set; }
        /// <summary>
        /// ID of the service instance generating the log in MRN format
        /// </summary>
        public string ServiceInstanceId { get; set; }

        /// <summary>
        /// Readable name of event
        /// </summary>
        public EventNumber EventNumber { get; set; }

        /// <summary>
        /// Type of event according to enumeration
        /// </summary>
        public EventType EventType { get; set; }

        /// <summary>
        /// Organisation ID for the external/opposite service instance (not my own ID)
        /// </summary>
        public string ExternalOrgId { get; set; }

        /// <summary>
        /// Entity ID of the external/opposite service instance (not my own ID)
        /// </summary>
        public string ExternalEntityId { get; set; }

        /// <summary>
        /// Attached parameters to the event in pair key:value or text/xml; charset=UTF8
        /// </summary>
        public string EventParameters { get; set; }

        /// <summary>
        /// Type of event data stored according to enumeration
        /// </summary>
        public EventDataType EventDataType { get; set; }

        /// <summary>
        /// Attached pay load data to the event according to eventDataType
        /// </summary>
        
        [Column(TypeName="text")]
        public string EventData { get; set; }

    }//end LogEvent
}