/* 
 * STM Ship Port Information Service STM Onboard API
 *
 * Ship Port Information Service API facing STM Onboard systems exposing interfaces to ships
 *
 * OpenAPI spec version: 1.0.0
 * Contact: per.lofbom@sjofartsverket.se
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;

namespace STM.SPIS.Services.Private.Models
{
    /// <summary>
    /// Message
    /// </summary>
    [DataContract]
    public partial class Message :  IEquatable<Message>, IValidatableObject
    {
        /// <summary>
        /// Gets or Sets MessageType
        /// </summary>
        [DataMember(Name="messageType", EmitDefaultValue=false)]
        public string MessageType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="Message" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Message() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Message" /> class.
        /// </summary>
        /// <param name="Id">Id (required).</param>
        /// <param name="ReceivedAt">ReceivedAt (required).</param>
        /// <param name="From">From (required).</param>
        /// <param name="MessageType">MessageType (required).</param>
        /// <param name="StmMessage">StmMessage (required).</param>
        /// <param name="CallbackEndpoint"></param>
        public Message(string Id = null, DateTime? ReceivedAt = null, string From = null, string MessageType = null, StmMessage StmMessage = null, string CallbackEndpoint = null)
        {
            this.Id = Id;
            this.ReceivedAt = ReceivedAt;
            this.From = From;
            this.MessageType = MessageType;
            this.StmMessage = StmMessage;
            this.CallbackEndpoint = CallbackEndpoint;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }
        /// <summary>
        /// Gets or Sets ReceivedAt
        /// </summary>
        [DataMember(Name="receivedAt", EmitDefaultValue=false)]
        public DateTime? ReceivedAt { get; set; }
        /// <summary>
        /// Gets or Sets From
        /// </summary>
        [DataMember(Name="from", EmitDefaultValue=false)]
        public string From { get; set; }
        /// <summary>
        /// Gets or Sets CallbackEndpoint
        /// </summary>
        public string CallbackEndpoint { get; set; }
        /// <summary>
        /// Gets or Sets StmMessage
        /// </summary>
        [DataMember(Name="stmMessage", EmitDefaultValue=false)]
        public StmMessage StmMessage { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Message {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  ReceivedAt: ").Append(ReceivedAt).Append("\n");
            sb.Append("  From: ").Append(From).Append("\n");
            sb.Append("  MessageType: ").Append(MessageType).Append("\n");
            sb.Append("  StmMessage: ").Append(StmMessage).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as Message);
        }

        /// <summary>
        /// Returns true if Message instances are equal
        /// </summary>
        /// <param name="other">Instance of Message to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Message other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.ReceivedAt == other.ReceivedAt ||
                    this.ReceivedAt != null &&
                    this.ReceivedAt.Equals(other.ReceivedAt)
                ) && 
                (
                    this.From == other.From ||
                    this.From != null &&
                    this.From.Equals(other.From)
                ) && 
                (
                    this.MessageType == other.MessageType ||
                    this.MessageType != null &&
                    this.MessageType.Equals(other.MessageType)
                ) && 
                (
                    this.StmMessage == other.StmMessage ||
                    this.StmMessage != null &&
                    this.StmMessage.Equals(other.StmMessage)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                if (this.ReceivedAt != null)
                    hash = hash * 59 + this.ReceivedAt.GetHashCode();
                if (this.From != null)
                    hash = hash * 59 + this.From.GetHashCode();
                if (this.MessageType != null)
                    hash = hash * 59 + this.MessageType.GetHashCode();
                if (this.StmMessage != null)
                    hash = hash * 59 + this.StmMessage.GetHashCode();
                return hash;
            }
        }

        public IEnumerable<ValidationResult> Validate(ValidationContext validationContext)
        { 
            // From (string) pattern
            Regex regexFrom = new Regex(@"urn:mrn:", RegexOptions.CultureInvariant);
            if (false == regexFrom.Match(this.From).Success)
            {
                yield return new ValidationResult("Invalid value for From, must match a pattern of /urn:mrn:/.", new [] { "From" });
            }

            yield break;
        }
    }

}
