/* 
 * STM Ship Port Information Service STM Onboard API
 *
 * Ship Port Information Service API facing STM Onboard systems exposing interfaces to ships
 *
 * OpenAPI spec version: 1.0.0
 * Contact: per.lofbom@sjofartsverket.se
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;

namespace STM.SPIS.Services.Private.Models
{
    /// <summary>
    /// MessageEnvelope
    /// </summary>
    [DataContract]
    public partial class MessageEnvelope :  IEquatable<MessageEnvelope>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MessageEnvelope" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        public MessageEnvelope() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="MessageEnvelope" /> class.
        /// </summary>
        /// <param name="NumberOfMessages">NumberOfMessages (required).</param>
        /// <param name="RemainingNumberOfMessages">RemainingNumberOfMessages (required).</param>
        /// <param name="Messages">Messages.</param>
        public MessageEnvelope(int? NumberOfMessages = default(int?), int? RemainingNumberOfMessages = default(int?), List<Message> Messages = default(List<Message>))
        {
            // to ensure "NumberOfMessages" is required (not null)
            if (NumberOfMessages == null)
            {
                throw new InvalidDataException("NumberOfMessages is a required property for MessageEnvelope and cannot be null");
            }
            else
            {
                this.NumberOfMessages = NumberOfMessages;
            }
            // to ensure "RemainingNumberOfMessages" is required (not null)
            if (RemainingNumberOfMessages == null)
            {
                throw new InvalidDataException("RemainingNumberOfMessages is a required property for MessageEnvelope and cannot be null");
            }
            else
            {
                this.RemainingNumberOfMessages = RemainingNumberOfMessages;
            }
            this.Messages = Messages;
        }
        
        /// <summary>
        /// Gets or Sets NumberOfMessages
        /// </summary>
        [DataMember(Name="numberOfMessages", EmitDefaultValue=false)]
        public int? NumberOfMessages { get; set; }
        /// <summary>
        /// Gets or Sets RemainingNumberOfMessages
        /// </summary>
        [DataMember(Name="remainingNumberOfMessages", EmitDefaultValue=false)]
        public int? RemainingNumberOfMessages { get; set; }
        /// <summary>
        /// Gets or Sets Message
        /// </summary>
        [DataMember(Name="message", EmitDefaultValue=false)]
        public List<Message> Messages { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MessageEnvelope {\n");
            sb.Append("  NumberOfMessages: ").Append(NumberOfMessages).Append("\n");
            sb.Append("  RemainingNumberOfMessages: ").Append(RemainingNumberOfMessages).Append("\n");
            sb.Append("  Messages: ").Append(Messages).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as MessageEnvelope);
        }

        /// <summary>
        /// Returns true if MessageEnvelope instances are equal
        /// </summary>
        /// <param name="other">Instance of MessageEnvelope to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MessageEnvelope other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.NumberOfMessages == other.NumberOfMessages ||
                    this.NumberOfMessages != null &&
                    this.NumberOfMessages.Equals(other.NumberOfMessages)
                ) && 
                (
                    this.RemainingNumberOfMessages == other.RemainingNumberOfMessages ||
                    this.RemainingNumberOfMessages != null &&
                    this.RemainingNumberOfMessages.Equals(other.RemainingNumberOfMessages)
                ) && 
                (
                    this.Messages == other.Messages ||
                    this.Messages != null &&
                    this.Messages.Equals(other.Messages)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.NumberOfMessages != null)
                    hash = hash * 59 + this.NumberOfMessages.GetHashCode();
                if (this.RemainingNumberOfMessages != null)
                    hash = hash * 59 + this.RemainingNumberOfMessages.GetHashCode();
                if (this.Messages != null)
                    hash = hash * 59 + this.Messages.GetHashCode();
                return hash;
            }
        }

        public IEnumerable<ValidationResult> Validate(ValidationContext validationContext)
        { 
            yield break;
        }
    }

}
