/*
 * STM SeaSwim Connector API
 *
 * SeaSwim Connector
 *
 * OpenAPI spec version: 1.0.0
 * Contact: frenda@cimne.upc.edu
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace STM.SSC.Internal.Models
{
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class ServiceRegistryGeneralRequestObj :  IEquatable<ServiceRegistryGeneralRequestObj>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ServiceRegistryGeneralRequestObj" /> class.
        /// </summary>
        /// <param name="Body">Body.</param>
        /// <param name="Headers">Headers.</param>
        /// <param name="RequestType">RequestType.</param>
        /// <param name="Url">Url.</param>
        public ServiceRegistryGeneralRequestObj(string Body = null, List<Header> Headers = null, string RequestType = null, string Url = null)
        {
            this.Body = Body;
            this.Headers = Headers;
            this.RequestType = RequestType;
            this.Url = Url;
            
        }

        /// <summary>
        /// Gets or Sets Body
        /// </summary>
        [DataMember(Name="body")]
        public string Body { get; set; }

        /// <summary>
        /// Gets or Sets Headers
        /// </summary>
        [DataMember(Name="headers")]
        public List<Header> Headers { get; set; }

        /// <summary>
        /// Gets or Sets RequestType
        /// </summary>
        [DataMember(Name="requestType")]
        public string RequestType { get; set; }

        /// <summary>
        /// Gets or Sets Url
        /// </summary>
        [DataMember(Name="url")]
        public string Url { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ServiceRegistryGeneralRequestObj {\n");
            sb.Append("  Body: ").Append(Body).Append("\n");
            sb.Append("  Headers: ").Append(Headers).Append("\n");
            sb.Append("  RequestType: ").Append(RequestType).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((ServiceRegistryGeneralRequestObj)obj);
        }

        /// <summary>
        /// Returns true if ServiceRegistryGeneralRequestObj instances are equal
        /// </summary>
        /// <param name="other">Instance of ServiceRegistryGeneralRequestObj to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ServiceRegistryGeneralRequestObj other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Body == other.Body ||
                    this.Body != null &&
                    this.Body.Equals(other.Body)
                ) && 
                (
                    this.Headers == other.Headers ||
                    this.Headers != null &&
                    this.Headers.SequenceEqual(other.Headers)
                ) && 
                (
                    this.RequestType == other.RequestType ||
                    this.RequestType != null &&
                    this.RequestType.Equals(other.RequestType)
                ) && 
                (
                    this.Url == other.Url ||
                    this.Url != null &&
                    this.Url.Equals(other.Url)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Body != null)
                    hash = hash * 59 + this.Body.GetHashCode();
                    if (this.Headers != null)
                    hash = hash * 59 + this.Headers.GetHashCode();
                    if (this.RequestType != null)
                    hash = hash * 59 + this.RequestType.GetHashCode();
                    if (this.Url != null)
                    hash = hash * 59 + this.Url.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(ServiceRegistryGeneralRequestObj left, ServiceRegistryGeneralRequestObj right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(ServiceRegistryGeneralRequestObj left, ServiceRegistryGeneralRequestObj right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
