/*
 * Maritime Cloud Service Registry API
 *
 * Maritime Cloud Service Registry, developed under the Horizon 2020 Project EfficienSea2, cofunded by the European Union.
 *
 * OpenAPI spec version: 1.0
 * Contact: josef.jahn@frequentis.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace STM.StmModule.Simulator.Contract
{
    /// <summary>
    /// Holds a description of a technical design.A design can be compatible to one or morespecification templates.It has at least a technical representation of thedescriptiion in form of an XML and a filled out templateas e.g. word document.
    /// </summary>
    [DataContract]
    public partial class Design :  IEquatable<Design>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Design" /> class.
        /// </summary>
        /// <param name="Comment">Comment.</param>
        /// <param name="DesignAsDoc">DesignAsDoc.</param>
        /// <param name="DesignAsXml">DesignAsXml.</param>
        /// <param name="DesignId">DesignId.</param>
        /// <param name="Docs">Docs.</param>
        /// <param name="Id">Id.</param>
        /// <param name="ImplementedSpecificationVersion">ImplementedSpecificationVersion.</param>
        /// <param name="Name">Name.</param>
        /// <param name="OrganizationId">OrganizationId.</param>
        /// <param name="Specifications">Specifications.</param>
        /// <param name="Status">Status.</param>
        /// <param name="Version">Version.</param>
        public Design(string Comment = null, Doc DesignAsDoc = null, Xml DesignAsXml = null, string DesignId = null, List<Doc> Docs = null, long? Id = null, SpecificationTemplate ImplementedSpecificationVersion = null, string Name = null, string OrganizationId = null, List<Specification> Specifications = null, string Status = null, string Version = null)
        {
            this.Comment = Comment;
            this.DesignAsDoc = DesignAsDoc;
            this.DesignAsXml = DesignAsXml;
            this.DesignId = DesignId;
            this.Docs = Docs;
            this.Id = Id;
            this.ImplementedSpecificationVersion = ImplementedSpecificationVersion;
            this.Name = Name;
            this.OrganizationId = OrganizationId;
            this.Specifications = Specifications;
            this.Status = Status;
            this.Version = Version;
            
        }

        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name="comment")]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets DesignAsDoc
        /// </summary>
        [DataMember(Name="designAsDoc")]
        public Doc DesignAsDoc { get; set; }

        /// <summary>
        /// Gets or Sets DesignAsXml
        /// </summary>
        [DataMember(Name="designAsXml")]
        public Xml DesignAsXml { get; set; }

        /// <summary>
        /// Gets or Sets DesignId
        /// </summary>
        [DataMember(Name="designId")]
        public string DesignId { get; set; }

        /// <summary>
        /// Gets or Sets Docs
        /// </summary>
        [DataMember(Name="docs")]
        public List<Doc> Docs { get; set; }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id")]
        public long? Id { get; set; }

        /// <summary>
        /// Gets or Sets ImplementedSpecificationVersion
        /// </summary>
        [DataMember(Name="implementedSpecificationVersion")]
        public SpecificationTemplate ImplementedSpecificationVersion { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets OrganizationId
        /// </summary>
        [DataMember(Name="organizationId")]
        public string OrganizationId { get; set; }

        /// <summary>
        /// Gets or Sets Specifications
        /// </summary>
        [DataMember(Name="specifications")]
        public List<Specification> Specifications { get; set; }

        /// <summary>
        /// Gets or Sets Status
        /// </summary>
        [DataMember(Name="status")]
        public string Status { get; set; }

        /// <summary>
        /// Gets or Sets Version
        /// </summary>
        [DataMember(Name="version")]
        public string Version { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Design {\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  DesignAsDoc: ").Append(DesignAsDoc).Append("\n");
            sb.Append("  DesignAsXml: ").Append(DesignAsXml).Append("\n");
            sb.Append("  DesignId: ").Append(DesignId).Append("\n");
            sb.Append("  Docs: ").Append(Docs).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  ImplementedSpecificationVersion: ").Append(ImplementedSpecificationVersion).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  OrganizationId: ").Append(OrganizationId).Append("\n");
            sb.Append("  Specifications: ").Append(Specifications).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((Design)obj);
        }

        /// <summary>
        /// Returns true if Design instances are equal
        /// </summary>
        /// <param name="other">Instance of Design to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Design other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Comment == other.Comment ||
                    this.Comment != null &&
                    this.Comment.Equals(other.Comment)
                ) && 
                (
                    this.DesignAsDoc == other.DesignAsDoc ||
                    this.DesignAsDoc != null &&
                    this.DesignAsDoc.Equals(other.DesignAsDoc)
                ) && 
                (
                    this.DesignAsXml == other.DesignAsXml ||
                    this.DesignAsXml != null &&
                    this.DesignAsXml.Equals(other.DesignAsXml)
                ) && 
                (
                    this.DesignId == other.DesignId ||
                    this.DesignId != null &&
                    this.DesignId.Equals(other.DesignId)
                ) && 
                (
                    this.Docs == other.Docs ||
                    this.Docs != null &&
                    this.Docs.SequenceEqual(other.Docs)
                ) && 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.ImplementedSpecificationVersion == other.ImplementedSpecificationVersion ||
                    this.ImplementedSpecificationVersion != null &&
                    this.ImplementedSpecificationVersion.Equals(other.ImplementedSpecificationVersion)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                ) && 
                (
                    this.OrganizationId == other.OrganizationId ||
                    this.OrganizationId != null &&
                    this.OrganizationId.Equals(other.OrganizationId)
                ) && 
                (
                    this.Specifications == other.Specifications ||
                    this.Specifications != null &&
                    this.Specifications.SequenceEqual(other.Specifications)
                ) && 
                (
                    this.Status == other.Status ||
                    this.Status != null &&
                    this.Status.Equals(other.Status)
                ) && 
                (
                    this.Version == other.Version ||
                    this.Version != null &&
                    this.Version.Equals(other.Version)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Comment != null)
                    hash = hash * 59 + this.Comment.GetHashCode();
                    if (this.DesignAsDoc != null)
                    hash = hash * 59 + this.DesignAsDoc.GetHashCode();
                    if (this.DesignAsXml != null)
                    hash = hash * 59 + this.DesignAsXml.GetHashCode();
                    if (this.DesignId != null)
                    hash = hash * 59 + this.DesignId.GetHashCode();
                    if (this.Docs != null)
                    hash = hash * 59 + this.Docs.GetHashCode();
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.ImplementedSpecificationVersion != null)
                    hash = hash * 59 + this.ImplementedSpecificationVersion.GetHashCode();
                    if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                    if (this.OrganizationId != null)
                    hash = hash * 59 + this.OrganizationId.GetHashCode();
                    if (this.Specifications != null)
                    hash = hash * 59 + this.Specifications.GetHashCode();
                    if (this.Status != null)
                    hash = hash * 59 + this.Status.GetHashCode();
                    if (this.Version != null)
                    hash = hash * 59 + this.Version.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(Design left, Design right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Design left, Design right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
