/*
 * Maritime Cloud Service Registry API
 *
 * Maritime Cloud Service Registry, developed under the Horizon 2020 Project EfficienSea2, cofunded by the European Union.
 *
 * OpenAPI spec version: 1.0
 * Contact: josef.jahn@frequentis.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace STM.StmModule.Simulator.Contract
{
    /// <summary>
    /// A doc represents a human readable document that can be attached to various objects.This could be an office document containing guidelines linked,to a service specification, or a Getting Started PDF attached toan service instance.
    /// </summary>
    [DataContract]
    public partial class Doc :  IEquatable<Doc>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Doc" /> class.
        /// </summary>
        /// <param name="Comment">Comment.</param>
        /// <param name="Filecontent">Filecontent.</param>
        /// <param name="FilecontentContentType">FilecontentContentType.</param>
        /// <param name="Id">Id.</param>
        /// <param name="Mimetype">Mimetype.</param>
        /// <param name="Name">Name.</param>
        public Doc(string Comment = null, string Filecontent = null, string FilecontentContentType = null, long? Id = null, string Mimetype = null, string Name = null)
        {
            this.Comment = Comment;
            this.Filecontent = Filecontent;
            this.FilecontentContentType = FilecontentContentType;
            this.Id = Id;
            this.Mimetype = Mimetype;
            this.Name = Name;
            
        }

        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name="comment")]
        public string Comment { get; set; }

        /// <summary>
        /// Gets or Sets Filecontent
        /// </summary>
        [DataMember(Name="filecontent")]
        public string Filecontent { get; set; }

        /// <summary>
        /// Gets or Sets FilecontentContentType
        /// </summary>
        [DataMember(Name="filecontentContentType")]
        public string FilecontentContentType { get; set; }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id")]
        public long? Id { get; set; }

        /// <summary>
        /// Gets or Sets Mimetype
        /// </summary>
        [DataMember(Name="mimetype")]
        public string Mimetype { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name")]
        public string Name { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Doc {\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  Filecontent: ").Append(Filecontent).Append("\n");
            sb.Append("  FilecontentContentType: ").Append(FilecontentContentType).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Mimetype: ").Append(Mimetype).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((Doc)obj);
        }

        /// <summary>
        /// Returns true if Doc instances are equal
        /// </summary>
        /// <param name="other">Instance of Doc to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Doc other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.Comment == other.Comment ||
                    this.Comment != null &&
                    this.Comment.Equals(other.Comment)
                ) && 
                (
                    this.Filecontent == other.Filecontent ||
                    this.Filecontent != null &&
                    this.Filecontent.SequenceEqual(other.Filecontent)
                ) && 
                (
                    this.FilecontentContentType == other.FilecontentContentType ||
                    this.FilecontentContentType != null &&
                    this.FilecontentContentType.Equals(other.FilecontentContentType)
                ) && 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Mimetype == other.Mimetype ||
                    this.Mimetype != null &&
                    this.Mimetype.Equals(other.Mimetype)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.Comment != null)
                    hash = hash * 59 + this.Comment.GetHashCode();
                    if (this.Filecontent != null)
                    hash = hash * 59 + this.Filecontent.GetHashCode();
                    if (this.FilecontentContentType != null)
                    hash = hash * 59 + this.FilecontentContentType.GetHashCode();
                    if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                    if (this.Mimetype != null)
                    hash = hash * 59 + this.Mimetype.GetHashCode();
                    if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                return hash;
            }
        }

        #region Operators

        public static bool operator ==(Doc left, Doc right)
        {
            return Equals(left, right);
        }

        public static bool operator !=(Doc left, Doc right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
