/*
 * STM Voyage Information Service SeaSWIM API
 *
 * Voyage Information Service API facing SeaSWIM through SSC exposing interfaces to SeaSWIM stakeholders
 *
 * OpenAPI spec version: 1.0.0
 * Contact: per.lofbom@sjofartsverket.se
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace STM.VIS.Services.Public.Models
{
    /// <summary>
    /// 
    /// </summary>
    [DataContract]
    public partial class S124DataSet :  IEquatable<S124DataSet>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="S124DataSet" /> class.
        /// </summary>
        /// <param name="DataSet">DataSet (required).</param>
        public S124DataSet(string DataSet = null)
        {
            // to ensure "DataSet" is required (not null)
            if (DataSet == null)
            {
                throw new InvalidDataException("DataSet is a required property for S124DataSet and cannot be null");
            }
            else
            {
                this.DataSet = DataSet;
            }
            
        }

        /// <summary>
        /// Gets or Sets DataSet
        /// </summary>
        [DataMember(Name="dataSet")]
        public string DataSet { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class S124DataSet {\n");
            sb.Append("  DataSet: ").Append(DataSet).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((S124DataSet)obj);
        }

        /// <summary>
        /// Returns true if S124DataSet instances are equal
        /// </summary>
        /// <param name="other">Instance of S124DataSet to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(S124DataSet other)
        {

            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;

            return 
                (
                    this.DataSet == other.DataSet ||
                    this.DataSet != null &&
                    this.DataSet.Equals(other.DataSet)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                    if (this.DataSet != null)
                    hash = hash * 59 + this.DataSet.GetHashCode();
                return hash;
            }
        }

        #region Operators

        /// <summary>
        /// 
        /// </summary>
        /// <param name="left"></param>
        /// <param name="right"></param>
        /// <returns></returns>
        public static bool operator ==(S124DataSet left, S124DataSet right)
        {
            return Equals(left, right);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="left"></param>
        /// <param name="right"></param>
        /// <returns></returns>
        public static bool operator !=(S124DataSet left, S124DataSet right)
        {
            return !Equals(left, right);
        }

        #endregion Operators

    }
}
